/** 
    Mohamed Lokbani
    Tableau d'objets

*/



class Annuaire {


    static private int nb = 0;  // partagee de tous les objets

    private String nom;
    private String telephone;

    public Annuaire (String nom, String telephone) {
	this.nom = nom;
	this.telephone = telephone;
	nb++;
    }

    // un annuaire sans entre!!! waoua! Imaginez des pages "blanches" vides!!!
    public Annuaire () {
	this.nom = "";
	this.telephone = "";
	nb++;
    }



    public String getNom() {return nom;} // retourne la note intra
    public String getTel() {return telephone;} // retourne la note intra


    public String toString(){
	return "Nom: " + nom + " ; Numro de Tlphone: " + telephone;
    }

    // ------------------
    // une methode static
    // ------------------
    
    public static int getNombreObjets() {
	return nb;
    }
    

}


public class annu {

    
    public static void main(String [] args) {
	Annuaire table [] = {new Annuaire("Paul","514 343 6111"), new Annuaire("Marc","212 540 5674"), new Annuaire("Julie","972 879 3102")};

	for (int i=0; i< table.length ; i++ )
	    System.out.println(table[i]);


	
	// un lment  la fois ...
	Annuaire a1 = new Annuaire("Paul","514 343 6111");
	Annuaire a2 = new Annuaire("Marc","212 540 5674");
	
	// NOTE: une methode static peut etre appellee sans qu'aucun objet de la
	// classe n'existe encore
	System.out.println("nombre objets: " + Annuaire.getNombreObjets());
	

	// une table de MAX  (NOTE: aucune entre cre ici)
	final int MAX = 5;

	Annuaire table2 [] = new Annuaire [MAX];
	
	System.out.println("nombre objets: " + Annuaire.getNombreObjets());
	
	
	// une table de dimension 2
	// cette table possede 2 lignes, la premiere contient 3 entres,
	// la seconde en contient 1 seule
	Annuaire table3 [][] = {{new Annuaire("toto", "514 323 3434"), new Annuaire("titi","514 345 6789"), new Annuaire("tutu","514 213 2345")},{new Annuaire("tata","514 678 4563")}};
	

	System.out.println("nombre objets: " + Annuaire.getNombreObjets());


	for (int i=0; i<MAX; i++) table2[i] = new Annuaire();

	System.out.println("nombre objets: " + Annuaire.getNombreObjets());


    }
}





